#include "SocketS.h"



DWORD WINAPI SocketS::ThreadProc(LPVOID lpParameter)
{
	SocketS* server = (SocketS*)lpParameter;
	HANDLE port = server->hPort;
	DWORD NumberOfBytes;
	ULONG_PTR index;
	LPOVERLAPPED lpOverlapped;

	while (server->g_flag)
	{
		BOOL bFlag = GetQueuedCompletionStatus(port, &NumberOfBytes, &index, &lpOverlapped, INFINITE);
		clienInfo* clien = &server->ClienMap[index];

		if (FALSE == bFlag)
		{
			if (64 == GetLastError())
			{
				printf("ͻ쳣\n");
				clien->c_Sock = 0;
				clien->c_Olp.hEvent = NULL;
				server->ClienMap.erase(index);
				if (server->Cfunc != NULL)
				{
					server->Cfunc(index);
				}
			}
			continue;
		}

		// ദ
		//lock_guard<std::mutex> guard(clien->msgLock);
		if (0 == index)	// accept
		{
			printf("accept\n");
			// 󶨵ɶ˿
			HANDLE hPort1 = CreateIoCompletionPort((HANDLE)server->ClienMap[server->g_count].c_Sock, port, server->g_count, 0);
			if (hPort1 != port)
			{
				printf("CreateIoCompletionPort ʧ error:%d\n", GetLastError());
				closesocket(server->ClienMap[server->g_count].c_Sock);

				continue;
			}
			server->PostRecv(server->g_count);	// Ͷrecv
			++server->g_count;			// ͻ++
			server->PostAccept();		// Ͷaccept
		}
		else
		{
			if (0 == NumberOfBytes)
			{
				printf("ͻ\n");

				closesocket(clien->c_Sock);
				WSACloseEvent(clien->c_Olp.hEvent);
				// ɾ
				clien->c_Sock = 0;
				clien->c_Olp.hEvent = NULL;
				server->ClienMap.erase(index);
				if (server->Cfunc != NULL)
				{
					server->Cfunc(index);
				}
			}
			else
			{
				if (0 != clien->c_strRecv)	// recv
				{
					// յͻϢ 
					int len = NumberOfBytes;
					char * buf = server->RecvBuff(index, clien->c_strRecv, len);

					while (buf)
					{
						if (server->Rfunc != NULL)
						{
							server->Rfunc(index, buf, len);
						}
						delete buf;
						len = 0;
						buf = server->RecvBuff(index,NULL, len);
					}
					memset(clien->c_strRecv, 0, sizeof(clien->c_strRecv));
					server->PostRecv(index);	// ԼͶݽ
				}
			}
		}

	}

	return 0;
}


SocketS::SocketS()
{
}


int SocketS::PostAccept(void)
{
	ClienMap[g_count].c_Sock = WSASocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, WSA_FLAG_OVERLAPPED);
	ClienMap[g_count].c_Olp.hEvent = WSACreateEvent();

	char str[1024] = { 0 };
	DWORD dwRecvcount;
	AcceptEx(ClienMap[0].c_Sock, ClienMap[g_count].c_Sock, str, 0, sizeof(struct sockaddr_in) + 16, sizeof(struct sockaddr_in) + 16, &dwRecvcount, &ClienMap[0].c_Olp);

	if (ERROR_IO_PENDING != WSAGetLastError())
	{
		return 1;	// ִг
	}
	return 0;
}

int SocketS::PostRecv(int index)
{
	WSABUF wsabuf;
	wsabuf.buf = ClienMap[index].c_strRecv;
	wsabuf.len = 1024;

	DWORD dwRecvCount;
	DWORD dwFlag = 0;
	WSARecv(ClienMap[index].c_Sock, &wsabuf, 1, &dwRecvCount, &dwFlag, &ClienMap[index].c_Olp, NULL);

	if (ERROR_IO_PENDING != WSAGetLastError())
	{
		return 1;	// ִг
	}
	return 0;
}

int SocketS::PostSend(int index, const char* buf, int len)
{
	if (ClienMap.find(index) != ClienMap.end())
	{
		lock_guard<std::mutex> guard(ClienMap[index].sendLock);
		if (ClienMap[index].c_Sock != 0)
		{
			return send(ClienMap[index].c_Sock, buf, len, 0);
		}
	}
	return -1;
}

char* SocketS::RecvBuff(int index, char* buf, int& len)
{
	char* buff = NULL;
	MsgHead* h;
	clienInfo* info = &ClienMap[index];
	lock_guard<std::mutex> guard(info->msgLock);
	if (len != 0)
		memcpy_s(info->buf + info->buflen, len, buf, len);
	info->buflen += len;

	if (info->buflen > sizeof(MsgHead))
	{
		h = (MsgHead*)info->buf;
		if (info->buflen - sizeof(MsgHead) >= h->bufLen)
		{
			buff = new char[h->bufLen + 1];
			ZeroMemory(buff, h->bufLen + 1);
			memcpy_s(buff, h->bufLen, info->buf + sizeof(MsgHead), h->bufLen);
			len = h->bufLen;
			info->buflen = info->buflen - len - sizeof(MsgHead);
			if (info->buflen > 0)
				memcpy_s(info->buf, info->buflen, info->buf + sizeof(MsgHead) + len, info->buflen);
		}
	}
	return buff;
}

BOOL SocketS::Creat(int Prot)
{
	// 
	WORD wVersionRequird = MAKEWORD(2, 2);	// MAKEWORD(汾,汾)
	WSADATA wdScokMsg;
	switch (WSAStartup(wVersionRequird, &wdScokMsg))
	{
	case WSASYSNOTREADY:
		printf("ԣ߼\n");
		return -1;

	case WSAVERNOTSUPPORTED:
		printf("\n");
		return -1;

	case WSAEPROCLIM:
		printf("볢ԹصҪΪǰṩԴ\n");
		return -1;

	case WSAEINPROGRESS:
		printf("\n");
		return -1;
	}

	// У汾
	if (2 != HIBYTE(wdScokMsg.wVersion) || 2 != LOBYTE(wdScokMsg.wVersion))
	{
		printf("汾\n");
		WSACleanup();
		return -1;
	}

	// socket
	SOCKET socketServer = WSASocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, WSA_FLAG_OVERLAPPED);
	if (INVALID_SOCKET == socketServer)
	{
		printf("WSASocketʧ error:%d\n", WSAGetLastError());
		WSACleanup();
		return -1;
	}

	// 󶨵ַ
	SOCKADDR_IN sockAddress;
	sockAddress.sin_family = AF_INET;
	sockAddress.sin_addr.S_un.S_addr = htonl(INADDR_ANY);	// INADDR_ANY --- κεַ
	sockAddress.sin_port = htons(Prot);
	if (SOCKET_ERROR == ::bind(socketServer, (struct sockaddr*)&sockAddress, sizeof(sockAddress)))
	{
		printf("bind ʧ error:%d\n", WSAGetLastError());
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	ClienMap[g_count].c_Sock = socketServer;
	ClienMap[g_count].c_Olp.hEvent = WSACreateEvent();
	++g_count;

	// ɶ˿
	hPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0);
	if (NULL == hPort)
	{
		printf("CreateIoCompletionPort ʧ error:%d\n", GetLastError());
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	// 󶨶˿SOCKET
	HANDLE hPort1 = CreateIoCompletionPort((HANDLE)socketServer, hPort, 0, 0);
	if (hPort1 != hPort)
	{
		printf("CreateIoCompletionPort ʧ error:%d\n", GetLastError());
		CloseHandle(hPort);
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	// ʼ
	if (SOCKET_ERROR == listen(socketServer, SOMAXCONN))
	{
		printf("listen ʧ error:%d\n", WSAGetLastError());
		CloseHandle(hPort);
		closesocket(socketServer);
		WSACleanup();
		return -1;
	}

	if (0 != PostAccept())
	{
		Close();
		WSACleanup();
		return -1;
	}

	// ȡҪ߳
	SYSTEM_INFO systemProcessorsCount;
	GetSystemInfo(&systemProcessorsCount);
	int nProcessorsCount = systemProcessorsCount.dwNumberOfProcessors;
	g_flag = TRUE;
	// ߳
	pThread = (HANDLE*)malloc(sizeof(HANDLE) * nProcessorsCount);
	for (int i = 0; i < nProcessorsCount; ++i)
	{
		pThread[i] = CreateThread(NULL, 0, ThreadProc, (LPVOID)this, 0, NULL);
		if (NULL == pThread[i])
		{
			printf("CreateThread ʧ error:%d\n", WSAGetLastError());
			CloseHandle(hPort);
			closesocket(socketServer);
			WSACleanup();
			return -1;
		}
	}

}

void SocketS::Close()
{
	g_flag = FALSE;
	for (auto i = ClienMap.begin(); i != ClienMap.end(); ++i)
	{
		if (0 == i->second.c_Sock)
		{
			continue;
		}
		closesocket(i->second.c_Sock);
		WSACloseEvent(i->second.c_Olp.hEvent);
	}
	ClienMap.clear();

	free(pThread);
	CloseHandle(hPort);
	WSACleanup();
	Rfunc = NULL;
	Cfunc = NULL;
}

VOID SocketS::SetRecvFunc(function<VOID(int, char*, int)> fun)
{
	Rfunc = fun;
}

VOID SocketS::SetCloseFunc(function<VOID(int)> fun)
{
	Cfunc = fun;
}

VOID SocketS::GetClienName(int index, string& IP, int& Prot)
{
	IP = "";
	Prot = 0;
	if(ClienMap.find(index)!= ClienMap.end())
	{
		if(ClienMap[index].c_Sock!=0)
		{
			struct sockaddr_in peerAddr;
			int peerLen = sizeof(peerAddr);
			getpeername(ClienMap[index].c_Sock, (struct sockaddr*)&peerAddr, &peerLen);
			IP = inet_ntoa(peerAddr.sin_addr);
			Prot = ntohs(peerAddr.sin_port);
		}
	}
}

int SocketS::Send(int index,const char* buf, int len)
{
	MsgHead h;
	h.bufLen = len;
	time(&h.tm);
	 
	char* buff = new char[sizeof(MsgHead) + len];
	memcpy_s(buff, sizeof(MsgHead), &h, sizeof(MsgHead));
	memcpy_s(buff + sizeof(MsgHead), len, buf, len);
	int lenth = PostSend(index, buff, len + sizeof(MsgHead)) - sizeof(MsgHead);
	delete[] buff;
	if (lenth < 0)
	{
		lenth = -1;
	}
	return lenth;
}

VOID SocketS::CloseClien(int index)
{
	if (ClienMap.find(index) != ClienMap.end())
	{
		ClienMap[index].msgLock.lock();
		WSACloseEvent(ClienMap[index].c_Olp.hEvent);
		shutdown(ClienMap[index].c_Sock, SD_BOTH);
		closesocket(ClienMap[index].c_Sock);
		ClienMap[index].msgLock.unlock();

		// ɾ
		ClienMap[index].c_Sock = 0;
		ClienMap[index].c_Olp.hEvent = NULL;
		ClienMap.erase(index);
	}
}

